#include <stdio.h>
#include <stdlib.h>
#include "raichu_alu.h"

unsigned int alu_atoi(char *str){
	return (unsigned int)(atoi(str));
}

unsigned int alu_neg(unsigned int in1){
	return (unsigned int)(-((int)in1));
}

unsigned int alu_add(unsigned int in1, unsigned int in2){
  return in1 + in2;
}

unsigned int alu_sub(unsigned int in1, unsigned int in2){
  return in1 - in2;
}

unsigned int alu_mul(unsigned int in1, unsigned int in2){
  return (unsigned int)(((int)in1) * ((int)in2));
}

unsigned int alu_div(unsigned int in1, unsigned int in2){
  int res;
  
  if(in2 == 0)
    return 0;
  
  res = (((int)in1) / ((int)in2));
  
  if(in2 == 2)
    return (unsigned int)res;
  else if(res >= 0 && res < 10)
    return (unsigned int)res;
  
  fprintf(stderr, "div used in unexpected way\n");
  
  return (unsigned int)res;
}

unsigned int alu_cmpeq(unsigned int in1, unsigned int in2){
  if(in1 == in2)
    return 0xffffffffU;
  return 0;
}

unsigned int alu_cmplt(unsigned int in1, unsigned int in2){
  if(((int)in1) < ((int)in2))
    return 0xffffffffU;
  return 0;
}

unsigned int alu_and(unsigned int in1, unsigned int in2){
  return (in1 & in2);
}

unsigned int alu_or(unsigned int in1, unsigned int in2){
  return (in1 | in2);
}

unsigned int alu_xor(unsigned int in1, unsigned int in2){
  return (in1 ^ in2);
}

unsigned int alu_not(unsigned int in1){
  return (~in1);
}

unsigned int alu_sll(unsigned int in1, unsigned int in2){
  in2 = in2 & 0x0000003fU;
  if(in2 >= 32)
    return 0;
  return (in1 << in2);
}

unsigned int alu_srl(unsigned int in1, unsigned int in2){
  in2 = in2 & 0x0000003fU;
  if(in2 >= 32)
    return 0;
  return (in1 >> in2);
}

unsigned int alu_sra(unsigned int in1, unsigned int in2){
  in2 = in2 & 0x0000003fU;
  if(in2 >= 32)
    return ((in1 & 0x80000000U) | ((in1 & 0x80000000U) - (in1 >> 31)));
  return (((in1 & 0x80000000U) | ((in1 & 0x80000000U) - ((in1 & 0x80000000U) >> in2))) | (in1 >> in2));
}
